#ifndef __ERRRORREPORT_HH_
#define __ERRRORREPORT_HH_
#include <errno.h>
#if defined(__linux) || defined(__ppc__)
#include <stdio.h>     // for sys_errlist[]
#endif
#ifdef WIN32
#include <windows.h>
#endif
//extern int errno;
//extern char *sys_errlist[];

class ErrorReport 
{
	int errornumber;
	int nerrors;
static	char nullerror[1];

public:
	ErrorReport():nerrors(0),errornumber(0){}
#ifndef WIN32
	void reportError(int err=errno){ // can fail for multithreaded programs
#else
	  void reportError(int err=WSAGetLastError()){
#endif
		errornumber=err;
		nerrors++; // if we ever want to store an error stack
	}

	void clearError(){ nerrors=errornumber=0; }
	int getError(){return errornumber;}
	int numErrors() { return nerrors; }
	int failed(){return errornumber;}

	const char *errorString()
	{
#if !defined(WIN32) && !defined(AIX)
		if(errornumber) return sys_errlist[errornumber];
		else return nullerror;
#else
		return nullerror;
#endif
		
	}
};
#endif // __ERRRORREPORT_HH_

